% Iris example for ny-iKFD with a metric similarity matrix (inner product kernel)
addpath(genpath('data'))
addpath(genpath('distools'))
addpath(genpath('prtools'))
addpath(genpath('argmaxmin'))
load iris_test
mD    = bsxfun(@rdivide,bsxfun(@minus,D,mean(D)),std(D));
K     = mD*mD';
R     = randsample(150,10);
[Y,L] = max(irisTargets);
ny{1} = K(:,R);
ny{2} = pinv(K(R,R));
ny{3} = R;
ny{4} = L;
W     = ny_ikfd(ny,L);
E     = getdata(W);
NrClasses = numel(E);
mPred = zeros(size(K,1),NrClasses);
for(k=1:NrClasses)
    C=getdata(E{k});
    for(i=1:size(K,1))
        mPred(i,k) = C.rot'*K(i,:)'+C.offset;
    end
end
vLabelPred = argmax(normcdf(mPred)');
mean(vLabelPred(:) == L(:))
[vModelResults,vClassifyResults,vProbabilities,vTestIndices] = crossvalidation_ny_ikfd(ny, L, 5);