% Singular value decomposition based on a nystroem approximated matrix
% The left-singular vectors of K are eigenvectors of KK*.
% The right-singular vectors of K are eigenvectors of K*K.
% The non-zero singular values of K (found on the diagonal entries of sigma) are the square roots of the non-zero eigenvalues of both M*M and MM*.
%
% Note: 
%      1)   ny_K is necessarily symmetric - hence U == V
%      2)   valid rank of U,V is obviously limited to the number of non-zero singular values
% long version - with eig_ny inplaced
function [U, S, V] = svd_ny_long(ny_K,RSample)
U = [];
V = [];
[N,m]   = size(ny_K{1});
K1   = ny_K{1};
Temp = (K1 * ny_K{2})';
Temp2 = (Temp*K1);
Ckk   = K1*Temp2;
%Ckk = zeros(N,m);
% for(k=1:N)
%     Ckk(k,:) = K1(k,:) * Temp2;
% end
nyKK1 = Ckk;
nyKK2 = pinv(Ckk(RSample,:));
%%%


Temp = nyKK2*(nyKK1'*nyKK1)*nyKK2;
Temp = 0.5 * (Temp+Temp');
[ny_U,ny_A]  = eig(Temp); % normalized cov on landmarks - eigendecomposition on B*B' (da quadrierte matrix wg neg ev
%ny_A(ny_A<eps) = 0;
%ny_A = real(ny_A);                        % may happen due to num inst
%ny_U = real(ny_U);
B=nyKK1*(ny_U*sqrt(ny_A));     % B = is the left / right part of the K_Nm * K_mm^-1 * K_Nm with inserted decomposition of K_mm^-1 in eigenvalues (U) and eigenvectors (L) 
[V,A] = eig(B'*B);               % eigenvalue decomposition of the covariance matrix of B to get eigenvectors V and eigenvalue matrix A
C=B*(V*sqrt(pinv(A)));           % now we have the eigenvector C of K and actually already the eigenvalue matrix A real(diag(sqrt(A))) - this works for psd matrices

% get eigenvalues of approximated matrix - for non-psd we have a
% to reconstruct the eigenvalues A as follows to avoid the sqrt(-1) issue
% Eigenvalue equation Av = lv
% get eigenvalues by starting with the eigenvectors C of A
% l  = v^-1 * A * v
% l  = (v^-1 * ny_K{1}) * ny_K{2} * ( ny_K{1} *v)
%[A,idx]=sort(diag((C'*nyKK1)*nyKK2*(nyKK1'*C)),'descend');
Temp    = (C'*nyKK1);
[A,idx] = sort(sum(Temp .* (nyKK2 * Temp')',2),'descend');
A=diag(A);
C=C(:,idx);





%%%
S       = sqrt(A);
[Y,I]   = sort(diag(S),'descend');
U       = C(:,I);
V       = U;

